FreeBSD src
Go to file
Jilles Tjoelker 484160a9cf sh: Add set -o pipefail
The pipefail option allows checking the exit status of all commands in a
pipeline more easily, at a limited cost of complexity in sh itself. It works
similarly to the option in bash, ksh93 and mksh.

Like ksh93 and unlike bash and mksh, the state of the option is saved when a
pipeline is started. Therefore, even in the case of commands like
  A | B &
a later change of the option does not change the exit status, the same way
  (A | B) &
works.

Since SIGPIPE is not handled specially, more work in the script is required
for a proper exit status for pipelines containing commands such as head that
may terminate successfully without reading all input. This can be something
like

(
        cmd1
        r=$?
        if [ "$r" -gt 128 ] && [ "$(kill -l "$r")" = PIPE ]; then
                exit 0
        else
                exit "$r"
        fi
) | head

PR:		224270
Relnotes:	yes
2019-02-24 21:05:13 +00:00
bin sh: Add set -o pipefail 2019-02-24 21:05:13 +00:00
cddl MFV r344364: 2019-02-20 17:10:30 +00:00
contrib Pull in r353299 from upstream lld trunk (by George Rimar): 2019-02-21 18:41:41 +00:00
crypto scp: validate filenames provided by server against wildcard in client 2019-02-21 22:45:54 +00:00
etc powerpc/boot: Move ubldr to /boot/uboot, and make this a separate filesystem 2019-02-18 01:57:47 +00:00
gnu Create crtsavres.o for powerpc builds 2019-01-12 21:29:54 +00:00
include Use a private definition of osockaddr rather then relying on type 2019-01-18 21:30:06 +00:00
kerberos5 Add WITH_PIE knob to build Position Independent Executables 2019-02-15 22:22:38 +00:00
lib 9058 postmortem DTrace frequently broken under vmware 2019-02-20 17:05:13 +00:00
libexec Add support for a virtual hostname to nfsd 2019-02-16 00:15:54 +00:00
release Fix sed script to insert Amazon NTP server into ntp.conf once rather 2019-02-19 23:24:39 +00:00
rescue rescue: set NO_SHARED in Makefile 2018-11-19 22:18:18 +00:00
sbin evdev: export event device properties through sysctl interface 2019-02-24 18:47:04 +00:00
secure Enable devcryptoeng for OpenSSL. 2018-12-12 21:56:47 +00:00
share style.mdoc.5: Fix a typo 2019-02-24 14:20:47 +00:00
stand loader: really fix cd9660 dirmatch 2019-02-20 21:07:09 +00:00
sys Fix build when EVDEV_SUPPORT is option disabled after r344494 2019-02-24 19:31:42 +00:00
targets retire LINKER_FEATURES filter flag 2018-11-12 20:44:22 +00:00
tests Allow the kcov buffer to be mmaped multiple times. 2019-02-21 10:11:15 +00:00
tools It turns out that setting the IV length is necessary with CCM in OpenSSL. 2019-02-20 21:24:56 +00:00
usr.bin svn: support building with WITH_PIE 2019-02-21 15:08:25 +00:00
usr.sbin An IPv6 address matching should be fixed. Specifying an IPv6 2019-02-24 03:41:05 +00:00
.arcconfig callsign isn't required anymore 2016-09-29 06:19:45 +00:00
.arclint arc lint: ignore /tests/ in chmod 2017-12-19 03:38:06 +00:00
.gitattributes MK_ZFS -> {MK_ZFS|MK_LOADER_ZFS}, this is so we can diable userland / kernel 2019-01-05 22:45:20 +00:00
.gitignore Ignore _.universe-toolchain file. 2018-07-01 13:50:37 +00:00
COPYRIGHT Happy New Year 2019! 2019-01-01 00:25:25 +00:00
LOCKS LOCKS: update current locks 2018-06-09 03:08:04 +00:00
MAINTAINERS Register a pre-commit review for ipfilter. 2018-12-24 01:12:22 +00:00
Makefile Update comment about 'universe' disk usage 2018-11-10 19:09:48 +00:00
Makefile.inc1 Remove iBCS2: plug a wart missed in r342242 2018-12-19 22:08:51 +00:00
Makefile.libcompat Use ...-freebsd13.0 in -target strings. 2018-11-12 16:55:20 +00:00
Makefile.sys.inc AUTO_OBJ: For all top-level targets enforce using an OBJDIR. 2017-12-05 21:29:47 +00:00
ObsoleteFiles.inc New pfil(9) KPI together with newborn pfil API and control utility. 2019-01-31 23:01:03 +00:00
README Import OpenSSL 1.1.1a. 2018-11-20 18:59:41 +00:00
README.md README: add generic notes about GENERIC and NOTES 2018-06-17 19:44:24 +00:00
UPDATING Add an UPDATING entry for the removal of drm and drm2 2019-02-19 19:37:09 +00:00

FreeBSD Source:

This is the top level of the FreeBSD source directory. This file was last revised on: FreeBSD

FreeBSD is an operating system used to power modern servers, desktops, and embedded platforms. A large community has continually developed it for more than thirty years. Its advanced networking, security, and storage features have made FreeBSD the platform of choice for many of the busiest web sites and most pervasive embedded networking and storage devices.

For copyright information, please see the file COPYRIGHT in this directory. Additional copyright information also exists for some sources in this tree - please see the specific source directories for more information.

The Makefile in this directory supports a number of targets for building components (or all) of the FreeBSD source tree. See build(7), config(8), https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/makeworld.html, and https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/kernelconfig.html for more information, including setting make(1) variables.

Source Roadmap:

bin		System/user commands.

cddl		Various commands and libraries under the Common Development
		and Distribution License.

contrib		Packages contributed by 3rd parties.

crypto		Cryptography stuff (see crypto/README).

etc		Template files for /etc.

gnu		Various commands and libraries under the GNU Public License.
		Please see gnu/COPYING* for more information.

include		System include files.

kerberos5	Kerberos5 (Heimdal) package.

lib		System libraries.

libexec		System daemons.

release		Release building Makefile & associated tools.

rescue		Build system for statically linked /rescue utilities.

sbin		System commands.

secure		Cryptographic libraries and commands.

share		Shared resources.

stand		Boot loader sources.

sys		Kernel sources.

sys/<arch>/conf Kernel configuration files. GENERIC is the configuration
		used in release builds. NOTES contains documentation of
		all possible entries.

tests		Regression tests which can be run by Kyua.  See tests/README
		for additional information.

tools		Utilities for regression testing and miscellaneous tasks.

usr.bin		User commands.

usr.sbin	System administration commands.

For information on synchronizing your source tree with one or more of the FreeBSD Project's development branches, please see:

https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/current-stable.html